;;;
;;; Theory
;;;


;;; Extensions Syntaxiques

(define (true  . x) (top))
(define (false . x) (bottom))

(define (<< (a) (b))
   (<% a b))
(define (<<< ,formals (a . ,formals) (b . ,formals))
   (<% a b))
(define (== (a) (b))
   (both (<% a b) (<% b a)))
(define (=== ,formals (a . ,formals) (b . ,formals))
   (both (<% a b) (<% b a)))

(define (converges (x))
   (true (x)))
(define (diverges (x))
   (<< (x) (false)))

(define (and . args)
   (*****))

(define (forsome ,formals (value . ,formals) ...)
   (and (apply value (a-list)) ...))
(define (exists . x)
   (apply true x))
(define (forall ,formals (predicate . ,formals) ...)
   (and (apply predicate (a-list)) ...))

(define (not?! (x))
   (<< (x) (false)))

(define (evals-to (expr) val)
   (<< val (expr)))
(define (not% (expr))
  (forsome (value)
     value
     (not?! (evals-to (expr) val))))

(define (if% (test) (yes) (no))
  (either (both (test) (yes))
	  (both (not% (test)) (no))))


;;; Structures de donnes

(define (a-thing) (top))
(define (nothing) (bottom))

(define (car x)
  (!forsome (a d) a (== x (cons a d))))
(define (cdr x)
  (!forsome (a d) d (== x (cons a d))))
(axiom cons$$constructs
  (forall (a d) (converges (cons a d))))
(axiom cons$$injective
  (forall (a1 d1 a2 d2)
     (<| (== (cons a1 d1) (cons a2 d2))
	 (and (== a1 a2) (== d1 d2)))))


(define (!null? x)
  (<< x '()))

(define (a-list)
  (either '() (cons (a-thing) (a-list))))



;;; Axiomes de base

(assume
  (*****))

;;; Logique classique

(define (classic-evaluation)
  (<<< (foo)
       (<% (not% (not% (foo))) (foo))))
(define (classic-convergence)
  (<<< (expr)
       (<< (<< (foo) (bottom)) (bottom))
       (converges (foo))))
(define (classic-booleans)
  (forall% (foo)
       (implies% (not% (not% (true (foo))) (true (foo))))))

(assume (classic-evaluation))




;;;
;;; Append
;;;
(define (append% x y)
   (and% (list?% x) (list?% y)
      (if% (null?% x) y
	   (cons (car x) (append% (cdr x) y)))))

; automatically produced by this definition:
(assume expand-append%
   (<<< (x y)
    (and% (list?% x) (list?% y)
	  (if% (null?% x) y
	       (cons (car x) (append% (cdr x) y))))
    (append% x y)))

(assume induct-append%
   (<<< (app)
     (<<< (x y)
       (and% (list?% x) (list?% y)
	     (if% (null?% x) y
		  (cons (car x) (app (cdr x) y))))
       (app x y))
     (<% append app)))
